<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CheckBalanceResponse StructType
 * @subpackage Structs
 */
class CheckBalanceResponse extends AbstractStructBase
{
    /**
     * The respcode
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $respcode;
    /**
     * The respmsg
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $respmsg;
    /**
     * The scbalance
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $scbalance;
    /**
     * The sccommbalance
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $sccommbalance;
    /**
     * Constructor method for CheckBalanceResponse
     * @uses CheckBalanceResponse::setRespcode()
     * @uses CheckBalanceResponse::setRespmsg()
     * @uses CheckBalanceResponse::setScbalance()
     * @uses CheckBalanceResponse::setSccommbalance()
     * @param string $respcode
     * @param string $respmsg
     * @param string $scbalance
     * @param string $sccommbalance
     */
    public function __construct($respcode = null, $respmsg = null, $scbalance = null, $sccommbalance = null)
    {
        $this
            ->setRespcode($respcode)
            ->setRespmsg($respmsg)
            ->setScbalance($scbalance)
            ->setSccommbalance($sccommbalance);
    }
    /**
     * Get respcode value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getRespcode()
    {
        return isset($this->respcode) ? $this->respcode : null;
    }
    /**
     * Set respcode value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $respcode
     * @return \StructType\CheckBalanceResponse
     */
    public function setRespcode($respcode = null)
    {
        // validation for constraint: string
        if (!is_null($respcode) && !is_string($respcode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($respcode)), __LINE__);
        }
        if (is_null($respcode) || (is_array($respcode) && empty($respcode))) {
            unset($this->respcode);
        } else {
            $this->respcode = $respcode;
        }
        return $this;
    }
    /**
     * Get respmsg value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getRespmsg()
    {
        return isset($this->respmsg) ? $this->respmsg : null;
    }
    /**
     * Set respmsg value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $respmsg
     * @return \StructType\CheckBalanceResponse
     */
    public function setRespmsg($respmsg = null)
    {
        // validation for constraint: string
        if (!is_null($respmsg) && !is_string($respmsg)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($respmsg)), __LINE__);
        }
        if (is_null($respmsg) || (is_array($respmsg) && empty($respmsg))) {
            unset($this->respmsg);
        } else {
            $this->respmsg = $respmsg;
        }
        return $this;
    }
    /**
     * Get scbalance value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getScbalance()
    {
        return isset($this->scbalance) ? $this->scbalance : null;
    }
    /**
     * Set scbalance value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $scbalance
     * @return \StructType\CheckBalanceResponse
     */
    public function setScbalance($scbalance = null)
    {
        // validation for constraint: string
        if (!is_null($scbalance) && !is_string($scbalance)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($scbalance)), __LINE__);
        }
        if (is_null($scbalance) || (is_array($scbalance) && empty($scbalance))) {
            unset($this->scbalance);
        } else {
            $this->scbalance = $scbalance;
        }
        return $this;
    }
    /**
     * Get sccommbalance value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getSccommbalance()
    {
        return isset($this->sccommbalance) ? $this->sccommbalance : null;
    }
    /**
     * Set sccommbalance value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $sccommbalance
     * @return \StructType\CheckBalanceResponse
     */
    public function setSccommbalance($sccommbalance = null)
    {
        // validation for constraint: string
        if (!is_null($sccommbalance) && !is_string($sccommbalance)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($sccommbalance)), __LINE__);
        }
        if (is_null($sccommbalance) || (is_array($sccommbalance) && empty($sccommbalance))) {
            unset($this->sccommbalance);
        } else {
            $this->sccommbalance = $sccommbalance;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\CheckBalanceResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
