<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PayBill StructType
 * @subpackage Structs
 */
class PayBill extends AbstractStructBase
{
    /**
     * The sccode
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $sccode;
    /**
     * The userid
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $userid;
    /**
     * The password
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $password;
    /**
     * The sctxnid
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $sctxnid;
    /**
     * The txntype
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $txntype;
    /**
     * The payeecode
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $payeecode;
    /**
     * The accountno
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $accountno;
    /**
     * The phoneno
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $phoneno;
    /**
     * The amount
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $amount;
    /**
     * The remark1
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $remark1;
    /**
     * The remark2
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $remark2;
    /**
     * Constructor method for PayBill
     * @uses PayBill::setSccode()
     * @uses PayBill::setUserid()
     * @uses PayBill::setPassword()
     * @uses PayBill::setSctxnid()
     * @uses PayBill::setTxntype()
     * @uses PayBill::setPayeecode()
     * @uses PayBill::setAccountno()
     * @uses PayBill::setPhoneno()
     * @uses PayBill::setAmount()
     * @uses PayBill::setRemark1()
     * @uses PayBill::setRemark2()
     * @param string $sccode
     * @param string $userid
     * @param string $password
     * @param string $sctxnid
     * @param string $txntype
     * @param string $payeecode
     * @param string $accountno
     * @param string $phoneno
     * @param string $amount
     * @param string $remark1
     * @param string $remark2
     */
    public function __construct($sccode = null, $userid = null, $password = null, $sctxnid = null, $txntype = null, $payeecode = null, $accountno = null, $phoneno = null, $amount = null, $remark1 = null, $remark2 = null)
    {
        $this
            ->setSccode($sccode)
            ->setUserid($userid)
            ->setPassword($password)
            ->setSctxnid($sctxnid)
            ->setTxntype($txntype)
            ->setPayeecode($payeecode)
            ->setAccountno($accountno)
            ->setPhoneno($phoneno)
            ->setAmount($amount)
            ->setRemark1($remark1)
            ->setRemark2($remark2);
    }
    /**
     * Get sccode value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getSccode()
    {
        return isset($this->sccode) ? $this->sccode : null;
    }
    /**
     * Set sccode value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $sccode
     * @return \StructType\PayBill
     */
    public function setSccode($sccode = null)
    {
        // validation for constraint: string
        if (!is_null($sccode) && !is_string($sccode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($sccode)), __LINE__);
        }
        if (is_null($sccode) || (is_array($sccode) && empty($sccode))) {
            unset($this->sccode);
        } else {
            $this->sccode = $sccode;
        }
        return $this;
    }
    /**
     * Get userid value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getUserid()
    {
        return isset($this->userid) ? $this->userid : null;
    }
    /**
     * Set userid value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $userid
     * @return \StructType\PayBill
     */
    public function setUserid($userid = null)
    {
        // validation for constraint: string
        if (!is_null($userid) && !is_string($userid)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($userid)), __LINE__);
        }
        if (is_null($userid) || (is_array($userid) && empty($userid))) {
            unset($this->userid);
        } else {
            $this->userid = $userid;
        }
        return $this;
    }
    /**
     * Get password value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getPassword()
    {
        return isset($this->password) ? $this->password : null;
    }
    /**
     * Set password value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $password
     * @return \StructType\PayBill
     */
    public function setPassword($password = null)
    {
        // validation for constraint: string
        if (!is_null($password) && !is_string($password)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($password)), __LINE__);
        }
        if (is_null($password) || (is_array($password) && empty($password))) {
            unset($this->password);
        } else {
            $this->password = $password;
        }
        return $this;
    }
    /**
     * Get sctxnid value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getSctxnid()
    {
        return isset($this->sctxnid) ? $this->sctxnid : null;
    }
    /**
     * Set sctxnid value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $sctxnid
     * @return \StructType\PayBill
     */
    public function setSctxnid($sctxnid = null)
    {
        // validation for constraint: string
        if (!is_null($sctxnid) && !is_string($sctxnid)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($sctxnid)), __LINE__);
        }
        if (is_null($sctxnid) || (is_array($sctxnid) && empty($sctxnid))) {
            unset($this->sctxnid);
        } else {
            $this->sctxnid = $sctxnid;
        }
        return $this;
    }
    /**
     * Get txntype value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getTxntype()
    {
        return isset($this->txntype) ? $this->txntype : null;
    }
    /**
     * Set txntype value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $txntype
     * @return \StructType\PayBill
     */
    public function setTxntype($txntype = null)
    {
        // validation for constraint: string
        if (!is_null($txntype) && !is_string($txntype)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($txntype)), __LINE__);
        }
        if (is_null($txntype) || (is_array($txntype) && empty($txntype))) {
            unset($this->txntype);
        } else {
            $this->txntype = $txntype;
        }
        return $this;
    }
    /**
     * Get payeecode value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getPayeecode()
    {
        return isset($this->payeecode) ? $this->payeecode : null;
    }
    /**
     * Set payeecode value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $payeecode
     * @return \StructType\PayBill
     */
    public function setPayeecode($payeecode = null)
    {
        // validation for constraint: string
        if (!is_null($payeecode) && !is_string($payeecode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($payeecode)), __LINE__);
        }
        if (is_null($payeecode) || (is_array($payeecode) && empty($payeecode))) {
            unset($this->payeecode);
        } else {
            $this->payeecode = $payeecode;
        }
        return $this;
    }
    /**
     * Get accountno value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getAccountno()
    {
        return isset($this->accountno) ? $this->accountno : null;
    }
    /**
     * Set accountno value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $accountno
     * @return \StructType\PayBill
     */
    public function setAccountno($accountno = null)
    {
        // validation for constraint: string
        if (!is_null($accountno) && !is_string($accountno)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($accountno)), __LINE__);
        }
        if (is_null($accountno) || (is_array($accountno) && empty($accountno))) {
            unset($this->accountno);
        } else {
            $this->accountno = $accountno;
        }
        return $this;
    }
    /**
     * Get phoneno value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getPhoneno()
    {
        return isset($this->phoneno) ? $this->phoneno : null;
    }
    /**
     * Set phoneno value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $phoneno
     * @return \StructType\PayBill
     */
    public function setPhoneno($phoneno = null)
    {
        // validation for constraint: string
        if (!is_null($phoneno) && !is_string($phoneno)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($phoneno)), __LINE__);
        }
        if (is_null($phoneno) || (is_array($phoneno) && empty($phoneno))) {
            unset($this->phoneno);
        } else {
            $this->phoneno = $phoneno;
        }
        return $this;
    }
    /**
     * Get amount value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getAmount()
    {
        return isset($this->amount) ? $this->amount : null;
    }
    /**
     * Set amount value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $amount
     * @return \StructType\PayBill
     */
    public function setAmount($amount = null)
    {
        // validation for constraint: string
        if (!is_null($amount) && !is_string($amount)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($amount)), __LINE__);
        }
        if (is_null($amount) || (is_array($amount) && empty($amount))) {
            unset($this->amount);
        } else {
            $this->amount = $amount;
        }
        return $this;
    }
    /**
     * Get remark1 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getRemark1()
    {
        return isset($this->remark1) ? $this->remark1 : null;
    }
    /**
     * Set remark1 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $remark1
     * @return \StructType\PayBill
     */
    public function setRemark1($remark1 = null)
    {
        // validation for constraint: string
        if (!is_null($remark1) && !is_string($remark1)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($remark1)), __LINE__);
        }
        if (is_null($remark1) || (is_array($remark1) && empty($remark1))) {
            unset($this->remark1);
        } else {
            $this->remark1 = $remark1;
        }
        return $this;
    }
    /**
     * Get remark2 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getRemark2()
    {
        return isset($this->remark2) ? $this->remark2 : null;
    }
    /**
     * Set remark2 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $remark2
     * @return \StructType\PayBill
     */
    public function setRemark2($remark2 = null)
    {
        // validation for constraint: string
        if (!is_null($remark2) && !is_string($remark2)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($remark2)), __LINE__);
        }
        if (is_null($remark2) || (is_array($remark2) && empty($remark2))) {
            unset($this->remark2);
        } else {
            $this->remark2 = $remark2;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\PayBill
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
